**Aumetar la memoria en uso**
clear all
set matsize 450


/*Se importa la base de datos de excel*/
import excel "D:\CIDE\7mo Semestre\Tesina\Ventosa\DATA BASES\STATA1.xlsx", firstrow clear 
destring , replace /*se usa la primera fila para nombrar las variables*/

**Programa STATA. ENDEUDAMIENTO Y ACTIVIDAD CAPARD**
**Estableciendo la base como panel**
**Costa Rica==1, El Salvador==2, Guatemala==3, Honduras==4, Nicaragua==5, Panama==6, Rep. Dominicana==7**
tsset numpais no
**Generate variables**

**Tasas de crecimiento anuales
by numpais: gen ccretotal=(cretotal/cretotal[_n-12])*100-100
by numpais: gen ccreprivado=(creprivado/creprivado[_n-12])*100-100
by numpais: gen cvencida=(vencida/vencida[_n-12])*100-100
by numpais: gen cimora=(imora/imora[_n-12])*100-100  
by numpais: gen ciriesgo=(iriesgo/iriesgo[_n-12])*100-100
by numpais: gen cicobertura=(icobertura/icobertura[_n-12])*100-100
by numpais: gen cimae=(imae/imae[_n-12])*100-100
by numpais: gen cipc=(ipc/ipc[_n-12])*100-100
by numpais: gen cinteres=(interes/interes[_n-12])*100-100
by numpais: gen ctasaencaje=(tasaencaje/tasaencaje[_n-12])*100-100
by numpais: gen ctdec=(tdec/tdec[_n-12])*100-100
by numpais: gen cnumbancos=(numbancos/numbancos[_n-12])*100-100
**Lags de las variables**
by numpais: gen lccreprivado=ccreprivado[_n-1]
by numpais: gen lcvencida=cvencida[_n-1]
by numpais: gen lcimora=cimora[_n-1]
**Logs**
by numpais: gen logcretotal=log(cretotal)
by numpais: gen logcreprivado=log(creprivado)
by numpais: gen logvencida=log(vencida)
by numpais: gen logimora=log(imora)
by numpais: gen logimae=log(imae)
by numpais: gen logipc=log(ipc)
by numpais: gen loginteres=log(interes)
by numpais: gen logtasaencaje=log(tasaencaje)
by numpais: gen logtdec=log(tdec)
by numpais: gen lognumbancos=log(numbancos)
**Laags de logs**
by numpais: gen llogcreprivado=logcreprivado[_n-1]
by numpais: gen l2logcreprivado=logcreprivado[_n-2]
by numpais: gen l3logcreprivado=logcreprivado[_n-3]
by numpais: gen llogvencida=logvencida[_n-1]
by numpais: gen l2logvencida=logvencida[_n-2]
by numpais: gen l3logvencida=logvencida[_n-3]
by numpais: gen llogimora=logimora[_n-1]

********************************************************************************
********************************************************************************

********************************NON-PERFORMING LOANS*********************************

/**************EFECTOS AGRUPADOS************************************************/
eststo: reg cvencida l.cvencida cimae cipc ctdec ctasaencaje cinteres cnumbancos dummycovid, robust
estat vif, uncentered /*NO HAY MULTICOLINEALIDAD*/
**reg cvencida l.cvencida cimae cipc ctdec ctasaencaje cinteres cnumbancos dummycovid, vce(robust)

/*******************************************************************************/

/***********************Fijos, aleaotrios***************************************/
**Efectos fijos**
eststo: xtreg cvencida l.cvencida cimae cipc ctdec ctasaencaje cinteres cnumbancos dummycovid,fe
predict ihat
corr ihat cvencida
di r(rho)^2
drop ihat
estimates store FE_CV

**Efetos Aleatorios**
eststo: xtreg cvencida l.cvencida cimae cipc ctdec ctasaencaje cinteres cnumbancos dummycovid,re
estimates store RE_CV
**Breushc Pagan aleatorios vs pooled**
xttest0

**Hausamn**
hausman FE_CV, sigmamore

**Prueba de autocorrelación Wooldrige**
xtserial cvencida lcvencida cimae cipc ctdec ctasaencaje cinteres cnumbancos dummycovid, output
**Corrección de autocorrelación**
xtregar cvencida lcvencida cimae cipc ctdec ctasaencaje cinteres cnumbancos dummycovid, fe
**Heteroscedasticidad**
qui xtreg cvencida l.cvencida cimae cipc ctdec ctasaencaje cinteres cnumbancos dummycovid,fe
xttest3
**Correlación contemporanea
xttest2

**FGLS**
eststo: xtgls cvencida l.cvencida cimae cipc ctdec ctasaencaje cinteres cnumbancos dummycovid i.numpais, panels(heteroskedastic) corr(ar1)
predict ihat
corr ihat cvencida
di r(rho)^2
drop ihat

**2SLS**
eststo: ivregress 2sls cvencida cimae cipc ctdec ctasaencaje cinteres cnumbancos dummycovid (l.cvencida= l.cimora l.cnumbancos)
estat first /*INSTUMENTOS RELEVANTES PARA LA ENDOGENEIDAD DE EL LAG*/
estat overid /*NO EXOGENEIDAD DE LOS INSTUMENTOS*/

**eststo: xtivreg2 cvencida cimae cipc ctasaencaje ctdec cinteres dummycovid (l.cvencida= l.cimora l.cnumbancos),fe
**predict ihat
**corr ihat cvencida
**di r(rho)^2
**drop ihat
**estimates store CV2


**Arellano-Bond**
eststo: xtabond cvencida cimae cipc ctdec ctasaencaje cinteres cnumbancos dummycovid ,lags(1)
predict ihat
corr ihat cvencida
di r(rho)^2
drop ihat
estat sargan
estimates store abond1
xtabond cvencida cimae cipc ctdec ctasaencaje cinteres cnumbancos dummycovid ,lags(1) vce(robust)
estat abond

esttab using "D:\CIDE\7mo Semestre\Tesina\Ventosa\DATA BASES\CV1.csv", label title(Results: Deuda y Actividad Económica (Var. %))  nonumbers mtitles( "FE" "VI" "GMM")  addnote("Fuente: Base CAPARD") se ar2 replace pr2 star(* 0.10 ** 0.05)
eststo clear
********************************************************************************
********************************************************************************

********************************PRIVATE CREDIT*********************************

/**************EFECTOS AGRUPADOS************************************************/
eststo: reg ccreprivado l.ccreprivado cimae cipc ctdec cinteres ctasaencaje cnumbancos dummycovid, robust
estat vif, uncentered /*NO HAY MULTICOLINEALIDAD*/
estimates store OLS_CP

/***********************Fijos, aleaotrios***************************************/
**Efectos fijos**
eststo: xtreg ccreprivado l.ccreprivado cimae cipc ctdec cinteres ctasaencaje cnumbancos dummycovid,fe
predict ihat
corr ihat ccreprivado
di r(rho)^2
drop ihat
estimates store FE_CP
**Efetos Aleatorios**
eststo: xtreg ccreprivado l.ccreprivado cimae cipc ctdec cinteres ctasaencaje cnumbancos dummycovid,re
estimates store RE_CP

**Breushc Pagan aleatorios vs pooled**
xttest0
**Hausamn**
hausman FE_CP, sigmamore

**Prueba de autocorrelación Wooldrige**
xtserial ccreprivado lccreprivado cimae cipc ctdec cinteres ctasaencaje cnumbancos dummycovid, output
**Corrección de autocorrelación**
xtregar ccreprivado lccreprivado cimae cipc ctdec cinteres ctasaencaje cnumbancos dummycovid, fe
**Heteroscedasticidad**
qui xtreg ccreprivado lccreprivado cimae cipc ctdec cinteres ctasaencaje cnumbancos dummycovid,fe
xttest3
**Correlación contemporanea
xttest2

**FGLS para corregir autocorrelación, hetroscedasticidad y correlación contemporanea**
eststo: xtgls ccreprivado l.ccreprivado cimae cipc ctdec cinteres ctasaencaje cnumbancos dummycovid i.numpais, panels(heteroskedastic) corr(ar1)
predict ihat
corr ihat ccreprivado
di r(rho)^2
drop ihat

**2SLS**
eststo:ivregress 2sls ccreprivado cimae cipc ctdec cinteres ctasaencaje cnumbancos dummycovid (l.ccreprivado=ll.ccreprivado i.numpais)
predict ihat
corr ihat ccreprivado
di r(rho)^2
drop ihat

estat first /*INSTUMENTOS RELEVANTES PARA LA ENDOGENEIDAD DE EL LAG*/
estat overid /*NO EXOGENEIDAD DE LOS INSTUMENTOS*/


**Arellano-Bond**
eststo: xtabond ccreprivado cimae cipc ctdec cinteres ctasaencaje cnumbancos dummycovid ,lags(1)
predict ihat
corr ihat ccreprivado
di r(rho)^2
drop ihat
estat sargan
estimates store abondCP
xtabond ccreprivado cimae cipc ctdec cinteres ctasaencaje cnumbancos dummycovid ,lags(1) vce(robust)
estat abond

esttab using "D:\CIDE\7mo Semestre\Tesina\Ventosa\DATA BASES\CP.csv", label title(Results: Deuda y Actividad Económica (Var. %))  nonumbers mtitles( "FE" "VI" "GMM")  addnote("Fuente: Base CAPARD") se ar2 replace pr2 star(* 0.10 ** 0.05)
eststo clear
